{ lib, config, options, pkgs, ... }:

with lib;
let cfg = config.modules.desktop.apps.code;
in {
  options.modules.desktop.apps.code = {
    enable = mkEnableOption false;
  };

  config = mkIf cfg.enable {
    programs.nix-ld = {
      enable = true;
      libraries = with pkgs; [
        stdenv.cc.cc.lib
      ];
    };
    environment.systemPackages = with pkgs; [
        rustc rustup # Rust
        # pkgs.rust-bin.stable.latest.default
        jetbrains.idea-ultimate
        jetbrains.rider
        jetbrains.clion
        jetbrains.pycharm-professional
        jetbrains.datagrip
        jetbrains.webstorm
        vim
        python3
        lua
        git
        github-desktop

        distrobox

        # -- C/C++
        gcc
        libgcc
        gnumake
        cmake
        extra-cmake-modules
    ];
  };
}