{ lib, config, options, pkgs, ... }:

with lib;
let cfg = config.modules.desktop.apps.godot;
in {
  options.modules.desktop.apps.godot = {
    enable = mkEnableOption false;
  };

  config = mkIf cfg.enable {
    programs.nix-ld.enable = true;
    programs.nix-ld.libraries = with pkgs; [
      libgcc
    ];

    environment.systemPackages = with pkgs.unstable; [
      godot_4
      godot_4-export-templates
      gcc-unwrapped
    ];

    environment.sessionVariables = { LD_LIBRARY_PATH = "${pkgs.stdenv.cc.cc.lib}/lib"; };
  };
}